"use strict";

exports.__esModule = true;
exports.default = void 0;

var _host = _interopRequireDefault(require("./host"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * Empty Component
 */
var EmptyComponent =
/*#__PURE__*/
function () {
  function EmptyComponent() {
    this._currentElement = null;
  }

  var _proto = EmptyComponent.prototype;

  _proto.mountComponent = function mountComponent(parent, parentInstance, context, childMounter) {
    this._parent = parent;
    this._parentInstance = parentInstance;
    this._context = context;
    var instance = {
      _internal: this
    };
    var nativeNode = this.getNativeNode();

    if (childMounter) {
      childMounter(nativeNode, parent);
    } else {
      _host.default.driver.appendChild(nativeNode, parent);
    }

    return instance;
  };

  _proto.unmountComponent = function unmountComponent(notRemoveChild) {
    if (this._nativeNode && !notRemoveChild) {
      _host.default.driver.removeChild(this._nativeNode, this._parent);
    }

    this._nativeNode = null;
    this._parent = null;
    this._parentInstance = null;
    this._context = null;
  };

  _proto.updateComponent = function updateComponent() {// Noop
  };

  _proto.getNativeNode = function getNativeNode() {
    // Weex native node
    if (this._nativeNode == null) {
      this._nativeNode = _host.default.driver.createEmpty();
    }

    return this._nativeNode;
  };

  return EmptyComponent;
}();

var _default = EmptyComponent;
exports.default = _default;