"use strict";

exports.__esModule = true;
exports.default = void 0;

var _host = _interopRequireDefault(require("./host"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * Text Component
 */
var TextComponent =
/*#__PURE__*/
function () {
  function TextComponent(element) {
    this._currentElement = element; // Text string

    this._text = String(element);
  }

  var _proto = TextComponent.prototype;

  _proto.mountComponent = function mountComponent(parent, parentInstance, context, childMounter) {
    this._parent = parent;
    this._parentInstance = parentInstance;
    this._context = context;
    this._mountID = _host.default.mountID++; // Weex dom operation

    var nativeNode = this.getNativeNode();

    if (childMounter) {
      childMounter(nativeNode, parent);
    } else {
      _host.default.driver.appendChild(nativeNode, parent);
    }

    var instance = {
      _internal: this
    };

    if (process.env.NODE_ENV !== 'production') {
      _host.default.hook.Reconciler.mountComponent(this);
    }

    return instance;
  };

  _proto.unmountComponent = function unmountComponent(notRemoveChild) {
    if (this._nativeNode && !notRemoveChild) {
      _host.default.driver.removeChild(this._nativeNode, this._parent);
    }

    if (process.env.NODE_ENV !== 'production') {
      _host.default.hook.Reconciler.unmountComponent(this);
    }

    this._currentElement = null;
    this._nativeNode = null;
    this._parent = null;
    this._parentInstance = null;
    this._context = null;
    this._text = null;
  };

  _proto.updateComponent = function updateComponent(prevElement, nextElement, context) {
    // If some text do noting
    if (prevElement !== nextElement) {
      // Replace current element
      this._currentElement = nextElement; // Devtool read the latest stringText value

      this._text = String(nextElement);

      _host.default.driver.updateText(this.getNativeNode(), this._text);

      if (process.env.NODE_ENV !== 'production') {
        _host.default.hook.Reconciler.receiveComponent(this);
      }
    }
  };

  _proto.getNativeNode = function getNativeNode() {
    if (this._nativeNode == null) {
      this._nativeNode = _host.default.driver.createText(this._text);
    }

    return this._nativeNode;
  };

  return TextComponent;
}();

var _default = TextComponent;
exports.default = _default;